#include "SFGameNative.h"
#include <sys/types.h>
#include <android/log.h>

#define  LOG(...)   __android_log_print(ANDROID_LOG_INFO, "newbee", ##__VA_ARGS__);

extern char s_localClsName[256];
JNIEnv* SFGameNative::mJNIEnv = 0;
SFNewBeeNativeIPayResulBack* SFGameNative::mSFIPayResulBack = 0;


//------------
SFNewBeeNativeInitResulBack* SFGameNative::mSFInitResulBack = 0;





void SFGameNative::init(JNIEnv* env) {
	mJNIEnv = env;
}


void SFGameNative::setSFIPayResulBack(SFNewBeeNativeIPayResulBack* payCallBack) {
	mSFIPayResulBack = payCallBack;
}

//========================================
void SFGameNative::setSFInitResulBack(SFNewBeeNativeInitResulBack* initCallBack) {
	mSFInitResulBack = initCallBack;
}





void SFGameNative::cmd(const char* id) {
	if (mJNIEnv == NULL) {
		LOG(" mJNIEnv = null");
		return;
	}

	const char* methodName = "cmd";
	jclass cls = mJNIEnv->FindClass(s_localClsName);

	if (cls == NULL){

		return;
	}

	jmethodID mid = mJNIEnv->GetStaticMethodID(cls, methodName,"(Ljava/lang/String;)V");

	if (mid == NULL){
		mJNIEnv->DeleteLocalRef(cls);

		return;
	}
	jstring jroleID =  mJNIEnv->NewStringUTF(id);
	mJNIEnv->CallStaticVoidMethod(cls, mid, jroleID);

	mJNIEnv->DeleteLocalRef(cls);
	mJNIEnv->DeleteLocalRef(jroleID);
}

void SFGameNative::cmdcge(const char* price, const char* chargeDesc) {
	if (mJNIEnv == NULL) {

		return;
	}

	const char* methodName = "cmdcge";
	jclass cls = mJNIEnv->FindClass(s_localClsName);

	if (cls == NULL){
		LOG("cls == NULL");
		return;
	}

	jmethodID mid = mJNIEnv->GetStaticMethodID(cls, methodName,"(Ljava/lang/String;Ljava/lang/String;)V");

	if (mid == NULL){

		return;
	}
	jstring jrolePrice =  mJNIEnv->NewStringUTF(price);
	jstring jroleChargeDesc =  mJNIEnv->NewStringUTF(chargeDesc);
	mJNIEnv->CallStaticVoidMethod(cls, mid, jrolePrice, jroleChargeDesc);

	mJNIEnv->DeleteLocalRef(cls);
	mJNIEnv->DeleteLocalRef(jrolePrice);
	mJNIEnv->DeleteLocalRef(jroleChargeDesc);

}


const char* SFGameNative::getValue(const char* key, const char* defaultValue) {
	if (mJNIEnv == NULL) {
		LOG(" mJNIEnv = null");
		return 0;
	}

	const char* methodName = "getValue";
	jclass cls = mJNIEnv->FindClass(s_localClsName);
	LOG("s_localClsName=%s,funanme=%s",s_localClsName, methodName);
	if (cls == NULL){
		LOG("cls == NULL");
		return 0;
	}
	jmethodID mid = mJNIEnv->GetStaticMethodID(cls, methodName,"(Ljava/lang/String;Ljava/lang/String;)Ljava/lang/String;");

	if (mid == NULL){
		LOG("mid == NULL");
		return 0;
	}
	jstring jroleKey =  mJNIEnv->NewStringUTF(key);
	jstring jroleDefaultValue =  mJNIEnv->NewStringUTF(defaultValue);
	jstring getValue=(jstring)mJNIEnv->CallStaticObjectMethod(cls, mid, jroleKey, jroleDefaultValue);

	const char* str = mJNIEnv->GetStringUTFChars(getValue, 0);
	mJNIEnv->ReleaseStringUTFChars(getValue, str);


	//	LOG("getValue return=%s", str);
	return str;
}


